# authentic2_auth_fedict - Fedict authentication for Authentic
# Copyright (C) 2016  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import lasso
from mellon.backends import SAMLBackend


class FedictBackend(SAMLBackend):
    def get_saml2_authn_context(self):
        # The Fedict will return one of:
        #  * urn:be:fedict:iam:fas:citizen:eid,
        #  * urn:be:fedict:iam:fas:citizen:token,
        #  * urn:be:fedict:iam:fas:enterprise:eid,
        #  * urn:be:fedict:iam:fas:citizen:token
        # but we do not expose this detail to the service provider as all it
        # needs to know is "strong authentication".
        return lasso.SAML2_AUTHN_CONTEXT_SMARTCARD_PKI
